# Generated by Django 4.1.13 on 2024-03-19 02:58

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import shortcut_util.unique


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="Permission",
            fields=[
                (
                    "id",
                    models.CharField(
                        default=shortcut_util.unique.uuid_id,
                        max_length=32,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("is_active", models.BooleanField(default=True, verbose_name="是否激活")),
                (
                    "create_datetime",
                    models.DateTimeField(auto_now_add=True, verbose_name="创建时间"),
                ),
                (
                    "update_datetime",
                    models.DateTimeField(auto_now=True, null=True, verbose_name="更新时间"),
                ),
                ("name", models.CharField(max_length=64, verbose_name="名称")),
                (
                    "description",
                    models.CharField(blank=True, max_length=256, verbose_name="描述"),
                ),
                (
                    "delete_datetime",
                    models.DateTimeField(blank=True, null=True, verbose_name="删除时间"),
                ),
                ("content_type", models.CharField(max_length=64, verbose_name="内容类型")),
                ("action", models.CharField(max_length=64, verbose_name="动作")),
                (
                    "create_user",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.RESTRICT,
                        related_name="created_%(app_label)s_%(class)ss",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "delete_user",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="deleted_%(app_label)s_%(class)ss",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "update_user",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="updated_%(app_label)s_%(class)ss",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "verbose_name": "权限表",
                "db_table": "admin_role_permission",
                "unique_together": {("content_type", "action")},
            },
        ),
        migrations.CreateModel(
            name="Role",
            fields=[
                (
                    "id",
                    models.CharField(
                        default=shortcut_util.unique.uuid_id,
                        max_length=32,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("is_active", models.BooleanField(default=True, verbose_name="是否激活")),
                (
                    "create_datetime",
                    models.DateTimeField(auto_now_add=True, verbose_name="创建时间"),
                ),
                (
                    "update_datetime",
                    models.DateTimeField(auto_now=True, null=True, verbose_name="更新时间"),
                ),
                ("name", models.CharField(max_length=64, verbose_name="名称")),
                (
                    "description",
                    models.CharField(blank=True, max_length=256, verbose_name="描述"),
                ),
                (
                    "delete_datetime",
                    models.DateTimeField(blank=True, null=True, verbose_name="删除时间"),
                ),
                ("code", models.CharField(max_length=64, verbose_name="编码")),
                ("type", models.CharField(max_length=32, verbose_name="类型")),
                (
                    "weight",
                    models.PositiveSmallIntegerField(verbose_name="权重，值越高优先级越高，即权限越大"),
                ),
                (
                    "create_user",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.RESTRICT,
                        related_name="created_%(app_label)s_%(class)ss",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "delete_user",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="deleted_%(app_label)s_%(class)ss",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "verbose_name": "角色表",
                "db_table": "admin_role",
            },
        ),
        migrations.CreateModel(
            name="RolePermissionRel",
            fields=[
                (
                    "id",
                    models.CharField(
                        default=shortcut_util.unique.uuid_id,
                        max_length=32,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("is_active", models.BooleanField(default=True, verbose_name="是否激活")),
                (
                    "create_datetime",
                    models.DateTimeField(auto_now_add=True, verbose_name="创建时间"),
                ),
                (
                    "update_datetime",
                    models.DateTimeField(auto_now=True, null=True, verbose_name="更新时间"),
                ),
                ("name", models.CharField(max_length=64, verbose_name="名称")),
                (
                    "description",
                    models.CharField(blank=True, max_length=256, verbose_name="描述"),
                ),
                (
                    "delete_datetime",
                    models.DateTimeField(blank=True, null=True, verbose_name="删除时间"),
                ),
                (
                    "create_user",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.RESTRICT,
                        related_name="created_%(app_label)s_%(class)ss",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "delete_user",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="deleted_%(app_label)s_%(class)ss",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "permission",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.RESTRICT,
                        to="admin_role.permission",
                    ),
                ),
                (
                    "role",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.RESTRICT,
                        to="admin_role.role",
                    ),
                ),
                (
                    "update_user",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="updated_%(app_label)s_%(class)ss",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "verbose_name": "角色权限关联表",
                "db_table": "admin_role_permission_rel",
                "unique_together": {("role", "permission")},
            },
        ),
        migrations.AddField(
            model_name="role",
            name="permissions",
            field=models.ManyToManyField(
                related_name="roles",
                through="admin_role.RolePermissionRel",
                to="admin_role.permission",
            ),
        ),
        migrations.AddField(
            model_name="role",
            name="update_user",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.SET_NULL,
                related_name="updated_%(app_label)s_%(class)ss",
                to=settings.AUTH_USER_MODEL,
            ),
        ),
        migrations.CreateModel(
            name="RoleSubjectRel",
            fields=[
                (
                    "id",
                    models.CharField(
                        default=shortcut_util.unique.uuid_id,
                        max_length=32,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("is_active", models.BooleanField(default=True, verbose_name="是否激活")),
                (
                    "create_datetime",
                    models.DateTimeField(auto_now_add=True, verbose_name="创建时间"),
                ),
                (
                    "update_datetime",
                    models.DateTimeField(auto_now=True, null=True, verbose_name="更新时间"),
                ),
                ("name", models.CharField(max_length=64, verbose_name="名称")),
                (
                    "description",
                    models.CharField(blank=True, max_length=256, verbose_name="描述"),
                ),
                (
                    "delete_datetime",
                    models.DateTimeField(blank=True, null=True, verbose_name="删除时间"),
                ),
                (
                    "subject_id",
                    models.CharField(help_text="主体id，用户id/组id", max_length=32),
                ),
                (
                    "subject_type",
                    models.CharField(help_text="主体类型，用户/组", max_length=32),
                ),
                ("scope", models.CharField(help_text="权限范围", max_length=32, null=True)),
                (
                    "expire_datetime",
                    models.DateTimeField(blank=True, null=True, verbose_name="过期时间"),
                ),
                (
                    "create_user",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.RESTRICT,
                        related_name="created_%(app_label)s_%(class)ss",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "delete_user",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="deleted_%(app_label)s_%(class)ss",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "role",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.RESTRICT,
                        related_name="subject_rels",
                        to="admin_role.role",
                    ),
                ),
                (
                    "update_user",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="updated_%(app_label)s_%(class)ss",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "verbose_name": "角色主体表",
                "db_table": "admin_role_subject_rel",
                "unique_together": {("subject_id", "role", "subject_type")},
            },
        ),
    ]
